/*
  Programme écrit par Silicium628
  ce logiciel est libre et open source

  */
#include "mainwindow.h"
#include "ui_mainwindow.h"
#include "vecteur2d_v2.cpp"
#include <stdlib.h>


// #include <QDebug>

QString version = "2.0";

QColor couleur_ecran = QColor::fromRgb(255, 255, 255, 255);
QColor couleur_ligne = QColor::fromRgb(0, 0, 0, 255);
QColor couleur_trace1 = QColor::fromRgb(255, 0, 0, 255);
QColor couleur_trace2 = QColor::fromRgb(0, 255, 0, 255);
QColor couleur_trace3 = QColor::fromRgb(0, 0, 255, 255);
QColor couleur_vecteur1 = QColor::fromRgb(255,100,0,255);
QColor couleur_vecteur2 = QColor::fromRgb(0, 179, 119, 255);
QColor couleur_vecteur3 = QColor::fromRgb(240, 240, 0, 255);
QColor couleur_texte = QColor::fromRgb(255, 255, 0, 255);

QPen pen_ligne(couleur_ligne, 1, Qt::SolidLine);
QPen pen_trace1(couleur_trace1, 1, Qt::SolidLine);
QPen pen_trace2(couleur_trace2, 1, Qt::SolidLine);
QPen pen_trace3(couleur_trace3, 1, Qt::SolidLine);
QPen pen_vecteur1(couleur_vecteur1, 1, Qt::SolidLine);
QPen pen_vecteur2(couleur_vecteur2, 1, Qt::SolidLine);
QPen pen_vecteur3(couleur_vecteur3, 1, Qt::SolidLine);
QPen pen_cadre(couleur_ligne, 1, Qt::SolidLine);


Vecteur2D V1, V2, V3,V4,V5;

double ext_x1, ext_y1, ext_x2, ext_y2;

double alpha0 =0;
double beta0 =0;
double gamma0 =0;

double offsetX = 425.0; // pour le tracé à l'écran
double offsetY = 427.0;

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent)
{

    setupUi(this);
    this->setFixedSize(1240, 960);
    setWindowTitle("Dessin Vecteurs2D - v" + version);

    scene = new QGraphicsScene(this);
    scene->setBackgroundBrush(couleur_ecran);

    graphicsView1->setScene(scene);
    graphicsView1->setGeometry(5,5,905,905); // POSITION et dimensions de l'écran

    pixmap1 = new QPixmap("papier_mil.jpg");
    scene->addPixmap(*pixmap1);

    groupe_axes = new QGraphicsItemGroup();
    scene->addItem(groupe_axes);
    groupe_cube = new QGraphicsItemGroup();
    scene->addItem(groupe_cube);
    groupe_vecteurs = new QGraphicsItemGroup();
    scene->addItem(groupe_vecteurs);

    tracer_cadre();


    pen_vecteur1.setWidth(2);
    pen_vecteur2.setWidth(2);
    pen_vecteur3.setWidth(2);

    V1.set_offsetX(offsetX); V1.set_offsetY(offsetY);
    V2.set_offsetX(offsetX); V2.set_offsetY(offsetY);

    V4.set_offsetX(offsetX); V4.set_offsetY(offsetY);
    V5.set_offsetX(offsetX); V5.set_offsetY(offsetY);

    tracer();
}



MainWindow::~MainWindow()
{

}



void MainWindow::effacer_vecteurs()
{
    foreach( QGraphicsItem *item, scene->items( groupe_vecteurs->boundingRect() ) )
    {
        if( item->group() == groupe_vecteurs )  { delete item; }
    }
}



void MainWindow::tracer_cadre()
{
    rectangle = new QGraphicsRectItem(0, 0, 900, 900);
    rectangle->setPen(pen_cadre);
    groupe_axes->addToGroup(rectangle);
}




void MainWindow::tracer()
{

    QString str1;
    effacer_vecteurs();

    double x1,y1;
    V1.set_dx(spinBox_dx1->value());
    V1.set_dy(spinBox_dy1->value());
    x1=spinBox_x1->value();
    y1=spinBox_y1->value();


    ext_x1 = x1+V1.get_dx();
    str1= QString::number(ext_x1, 'f', 2);
    lineEdit_extr_x1->setText(str1);

    ext_y1 = y1+V1.get_dy();
    str1= QString::number(ext_y1, 'f', 2);
    lineEdit_extr_y1->setText(str1);


    double x2,y2;
    V2.set_dx(spinBox_dx2->value());
    V2.set_dy(spinBox_dy2->value());
    x2=spinBox_x2->value();
    y2=spinBox_y2->value();


    ext_x2 = x2+V2.get_dx();
    str1= QString::number(ext_x2, 'f', 2);
    lineEdit_extr_x2->setText(str1);

    ext_y2 = y2+V2.get_dy();
    str1= QString::number(ext_y2, 'f', 2);
    lineEdit_extr_y2->setText(str1);

    double x3,y3;
    x3=0;
    y3=0;

    V3=V1+V2;
    V3.set_offsetX(offsetX); V3.set_offsetY(offsetY);


    str1= QString::number(V3.get_dx(), 'f', 2);
    lineEdit_dx3->setText(str1);

    str1= QString::number(V3.get_dy(), 'f', 2);
    lineEdit_dy3->setText(str1);

    int ecr =0; // ecrire
    if(checkBox_lettres->isChecked()) {ecr=1;}
    int c1 =0; //cercle1
    if(checkBox_cercle1->isChecked()) {c1=1;}
    int c2 =0;//cercle2
    if(checkBox_cercle2->isChecked()) {c2=1;}
    int c3 =0;//cercle3
    if(checkBox_cercle3->isChecked()) {c3=1;}

    int prj1=0; // projection du vecteur1 sur les axes
    if(checkBox_prj1->isChecked()) {prj1=1;}
    int prj2=0; // projection du vecteur2 sur les axes
    if(checkBox_prj2->isChecked()) {prj2=1;}
    int prj3=0; // projection du vecteur3 sur les axes
    if(checkBox_prj3->isChecked()) {prj3=1;}

    QString ltr; // 2 lettres

    ltr = lineEdit_lettres3->text();
    if(checkBox_dessin_V3->isChecked()) {V3.dessiner(x3,y3,groupe_vecteurs,pen_vecteur3, 1, ltr, ecr, c3,prj3); }

    ltr = lineEdit_lettres1->text();
    V1.dessiner(x1,y1,groupe_vecteurs,pen_vecteur1, 1, ltr, ecr, c1,prj1);

    ltr = lineEdit_lettres2->text();
    if(checkBox_dessin_V2->isChecked()) { V2.dessiner(x2,y2,groupe_vecteurs,pen_vecteur2,1,ltr, ecr, c2,prj2);}

    if((checkBox_dessin_paral->isChecked())&&(x1==0)&&(x1==0)&&(x2==0)&&(y1==0))
    {
// dessine le parallélogramme
        V4=V2;
        V4.dessiner(ext_x1,ext_y1,groupe_vecteurs,pen_ligne,0,"",0,0,0);
        V5=V1;
        V5.dessiner(ext_x2,ext_y2,groupe_vecteurs,pen_ligne,0,"",0,0,0);
    }

    // tracer les axes

       ligne1 = new QGraphicsLineItem(offsetX,900,offsetX,0); // ligne V
       groupe_axes->addToGroup(ligne1);

       ligne1 = new QGraphicsLineItem(0,offsetY,900,offsetY); // ligne H
       groupe_axes->addToGroup(ligne1);


    double prod_scalaire;
    prod_scalaire = V1.get_dx()* V2.get_dx() + V1.get_dy()*V2.get_dy();
    str1= QString::number(prod_scalaire, 'f', 4);
    lineEdit_scalaire->setText(str1);


}


void MainWindow::on_spinBox_dx1_valueChanged(double ){ tracer(); }
void MainWindow::on_spinBox_dy1_valueChanged(double ){ tracer(); }
void MainWindow::on_spinBox_x1_valueChanged(double ) { tracer(); }
void MainWindow::on_spinBox_y1_valueChanged(double ) { tracer(); }
void MainWindow::on_spinBox_dx2_valueChanged(double ){ tracer(); }
void MainWindow::on_spinBox_dy2_valueChanged(double ){ tracer(); }
void MainWindow::on_spinBox_x2_valueChanged(double ) { tracer(); }
void MainWindow::on_spinBox_y2_valueChanged(double ) { tracer(); }

void MainWindow::on_Btn_dx1_inv_clicked()
{
    spinBox_dx1->setValue(-spinBox_dx1->value());
}

void MainWindow::on_Btn_dy1_inv_clicked()
{
    spinBox_dy1->setValue(-spinBox_dy1->value());
}

void MainWindow::on_spinBox_x1_raz_clicked()
{
    spinBox_x1->setValue(0);
}

void MainWindow::on_spinBox_y1_raz_clicked()
{
    spinBox_y1->setValue(0);
}


void MainWindow::on_Btn_dx2_inv_clicked()
{
    spinBox_dx2->setValue(-spinBox_dx2->value());
}

void MainWindow::on_Btn_dy2_inv_clicked()
{
    spinBox_dy2->setValue(-spinBox_dy2->value());
}

void MainWindow::on_spinBox_x2_raz_clicked()
{
    spinBox_x2->setValue(0);
}

void MainWindow::on_spinBox_y2_raz_clicked()
{
    spinBox_y2->setValue(0);
}

void MainWindow::on_Btn_boutabout_clicked()
{
    spinBox_x2->setValue(ext_x1);
    spinBox_y2->setValue(ext_y1);

}

void MainWindow::on_Btb_dessin_origine_clicked()
{
    spinBox_x1->setValue(0);
    spinBox_y1->setValue(0);
    spinBox_x2->setValue(0);
    spinBox_y2->setValue(0);
}

void MainWindow::on_checkBox_dessin_V3_clicked()    { tracer();}
void MainWindow::on_checkBox_dessin_paral_clicked() { tracer();}
void MainWindow::on_checkBox_dessin_V2_clicked()    { tracer();}
void MainWindow::on_checkBox_lettres_clicked()          { tracer();}
void MainWindow::on_lineEdit_lettres1_editingFinished() { tracer();}
void MainWindow::on_lineEdit_lettres2_editingFinished() { tracer();}
void MainWindow::on_lineEdit_lettres3_editingFinished() { tracer();}
void MainWindow::on_checkBox_cercle1_clicked()  { tracer();}
void MainWindow::on_checkBox_cercle2_clicked()  { tracer();}
void MainWindow::on_checkBox_cercle3_clicked()  { tracer();}
void MainWindow::on_checkBox_prj1_clicked()     { tracer();}
void MainWindow::on_checkBox_prj2_clicked()     { tracer();}
void MainWindow::on_checkBox_prj3_clicked()     { tracer();}
