#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include "ui_mainwindow.h"
#include <QGraphicsView>
#include <QGraphicsTextItem>
#include <QGraphicsLineItem>
#include <QGraphicsItemGroup>


#include "vecteur2d_v2.h"




class MainWindow : public QMainWindow, public Ui::MainWindow
{
    Q_OBJECT
    
public:
    explicit MainWindow(QWidget *parent = 0);
    ~MainWindow();
    
private slots:

    void tracer_cadre();
    void effacer_vecteurs();

    void tracer();

    void on_spinBox_dx1_valueChanged(double);
    void on_spinBox_dy1_valueChanged(double arg1);
    void on_spinBox_x1_valueChanged(double arg1);
    void on_spinBox_y1_valueChanged(double arg1);

    void on_spinBox_dx2_valueChanged(double arg1);
    void on_spinBox_dy2_valueChanged(double arg1);
    void on_spinBox_x2_valueChanged(double arg1);
    void on_spinBox_y2_valueChanged(double arg1);

    void on_Btn_dx1_inv_clicked();
    void on_Btn_dy1_inv_clicked();
    void on_spinBox_x1_raz_clicked();
    void on_spinBox_y1_raz_clicked();

    void on_Btn_dx2_inv_clicked();
    void on_Btn_dy2_inv_clicked();
    void on_spinBox_x2_raz_clicked();
    void on_spinBox_y2_raz_clicked();

    void on_Btn_boutabout_clicked();

    void on_Btb_dessin_origine_clicked();

    void on_checkBox_dessin_V3_clicked();

    void on_checkBox_dessin_paral_clicked();

    void on_checkBox_dessin_V2_clicked();

    void on_checkBox_lettres_clicked();

    void on_lineEdit_lettres1_editingFinished();

    void on_lineEdit_lettres2_editingFinished();

    void on_lineEdit_lettres3_editingFinished();

    void on_checkBox_cercle1_clicked();

    void on_checkBox_cercle2_clicked();

    void on_checkBox_cercle3_clicked();

    void on_checkBox_prj1_clicked();

    void on_checkBox_prj2_clicked();

    void on_checkBox_prj3_clicked();

private:

    QGraphicsScene *scene;
    QGraphicsItemGroup *groupe_axes;
    QGraphicsItemGroup *groupe_cube;
    QGraphicsItemGroup *groupe_vecteurs;

    QGraphicsLineItem *axeX;
    QGraphicsLineItem *axeY;
    QGraphicsLineItem *axeZ;

    QGraphicsLineItem *ligne1;
    QGraphicsLineItem *ligne2;

    QGraphicsRectItem *rectangle;


    QPixmap *pixmap1;


};

#endif // MAINWINDOW_H
